# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/python/tags/
image: python:latest

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
.cache: &python-cache
  paths:
    - .cache/pip
    - venv/

stages:
  - test
  - package
  - prepare_release
  - release

.setup-virtualenv: &setup-virtualenv
  - python -V  # Print out python version for debugging
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate

test:
  stage: test
  before_script:
    - *setup-virtualenv
  cache:
    *python-cache
  script:
    - pip install tox
    - tox -e test-cov,flake8,mypy
  artifacts:
    when: always
    reports:
      cobertura: coverage.xml
      junit: report.xml

include:
  - template: Security/SAST.gitlab-ci.yml

package:
  stage: package
  cache:
    *python-cache
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_COMMIT_BRANCH
  before_script:
    - *setup-virtualenv
  script:
    - python setup.py sdist bdist_wheel
  artifacts:
    paths:
      - dist/*